//**************************
//* TP 5 - Arbres bianires *
//**************************

#include <iostream>

using namespace std;

struct Arbre{
  int v;
  Arbre* g;
  Arbre* d;
};

Arbre* creer(int v,Arbre* g,Arbre* d){
  Arbre* res=new Arbre;
  res->v=v;
  res->g=g;
  res->d=d;
  return res;
}

//**************
//* Exercice 2 *
//**************

//Question 1 -- Prefixe
//Pour T : 8 5 7 21 8 16 23 9 11 17

void prefixe(Arbre* A){
  if(A!=NULL){
    cout<<' '<<A->v;
    prefixe(A->g);
    prefixe(A->d);
  }
}

//Question 2 -- Infixe
//Pour T : 7 5 8 21 16 8 11 9 23 17

void infixe(Arbre* A){
  if(A!=NULL){
    infixe(A->g);
    cout<<' '<<A->v;
    infixe(A->d);
  }
}

//Question 3 -- Postfixe
//Pour T : 7 8 16 21 5 11 9 17 23 8
void postfixe(Arbre* A){
  if(A!=NULL){
    postfixe(A->g);
    postfixe(A->d);
    cout<<' '<<A->v;
  }
}

//**************
//* Exercice 3 *
//**************

// Question 1 -- Nombre noeuds
int noeuds(Arbre* A){
  if(A==NULL) return 0;
  return 1+noeuds(A->g)+noeuds(A->d);
}

// Question 2 -- Nombre feuilles
int feuilles(Arbre* A){
  // Si A est vide
  if(A==NULL) return 0;
  // Si A est une feuille 
  if(A->g==NULL and A->d==NULL){
    return 1;
  }
  // Si A est un noeud interne
  return feuilles(A->g)+feuilles(A->d);
}

// Question 3 -- Nombre noeuds internes
int noeuds_internes(Arbre* A){
  // Si A est vide 
  if(A==NULL) return 0;
  // Si A est une feuille 
  if(A->g==NULL and A->d==NULL){
    return 0;
  }
  // Si A est un noeud interne
  return 1+noeuds_internes(A->g)+noeuds_internes(A->d);
}

//**************
//* Exercice 4 *
//**************

// Question 1 -- Hauteur de l'arbre
int hauteur(Arbre* A){
  // L'arbre vide est de hauteur -1
  if(A==NULL) return -1;
  return 1+max(hauteur(A->g),hauteur(A->d));
}

// Question 2 -- Nombre de noeuds de l'arbre à la pronfondeur p
int nombre_profondeur(Arbre* A,int p){
  if(A==NULL) return 0;
  if(p==0) return 1;
  return nombre_profondeur(A->g,p-1)+nombre_profondeur(A->d,p-1);
}

// Question 3 -- Affichage des noeuds de l'arbre à la pronfondeur p
void affiche_profondeur(Arbre* A,int p){
  if(A!=NULL){
    if(p==0){
      cout<<A->v<<' ';
    }
    affiche_profondeur(A->g,p-1);
    affiche_profondeur(A->d,p-1);
  }
}

//**************
//* Exercice 5 *
//**************

// Question 1 -- Teste si l'arbre est plein

bool est_plein(Arbre* A){
  if(A==NULL) return true;
  if(A->g==NULL and A->d==NULL) return true;
  if(A->g!=NULL and A->d!=NULL){
    return (est_plein(A->g) and est_plein(A->d));
  }
  return false;
}

// Question 2 -- Teste si un arbre est complet

//Fonction qui retoune la hauteur de A si est complet
//Retourne -2 si A n'est pas complet

int est_complet_hauteur(Arbre* A){
  if(A==NULL) return -1;
  if(A->g==NULL and A->d==NULL) return 0;
  if(A->g!=NULL and A->d!=NULL){
    int hg=est_complet_hauteur(A->g);
    int hd=est_complet_hauteur(A->d);
    if(hg==-2 or hd==-2 or hg!=hd) return -2;
    return 1+hg; //Ici hg vaut hd
  }
  return -2;
}

bool est_complet(Arbre* A){
  return est_complet_hauteur(A)!=-2;
}

// Question 3 -- Teste si un arbre est equilibre

//Fonction qui retoune la hauteur de A si est equilibre
//Retourne -2 si A n'est pas complet

int abs(int a){
  if(a<0){
    return -a;
  }
  return a;
}

int est_equilibre_hauteur(Arbre* A){
  if(A==NULL) return -1;
  int hg=est_equilibre_hauteur(A->g);
  int hd=est_equilibre_hauteur(A->d);
  if(hg==-2 or hd==-2 or abs(hg-hd)>1){
    return -2;
  }
  return 1+max(hg,hd); //Ici hg vaut hd
}

bool est_equilibre(Arbre* A){
  return est_equilibre_hauteur(A)!=-2;
}


//********
//* Main *
//********

int main(){
  Arbre* T=creer(8,
		 creer(5,
		       creer(7,NULL,NULL),
		       creer(21,
			     creer(8,NULL,NULL),
			     creer(16,NULL,NULL)
			     )
		       ),
		 creer(23,
		       creer(9,
			     creer(11,NULL,NULL),
			     NULL
			     ),
		       creer(17,NULL,NULL)
		       )
		 );
  
  cout<<"**************"<<endl;
  cout<<"* Exercice 2 *"<<endl;
  cout<<"**************"<<endl;
  cout<<endl;
  cout<<"1. Préfixé : ";
  prefixe(T);
  cout<<endl;
  cout<<"2. Infixé : ";
  infixe(T);
  cout<<endl;
  cout<<"3. Postfixé : ";
  postfixe(T);
  cout<<endl;
  cout<<endl;
  cout<<"**************"<<endl;
  cout<<"* Exercice 3 *"<<endl;
  cout<<"**************"<<endl;
  cout<<endl;
  cout<<"1. Nombre noeuds dans T : "<<noeuds(T)<<endl;
  cout<<"2. Nombre de feuilles dans T : "<<feuilles(T)<<endl;
  cout<<"3. Nombre de noeuds internes dans T : "<<noeuds_internes(T)<<endl;
  cout<<endl;
  cout<<"**************"<<endl;
  cout<<"* Exercice 4 *"<<endl;
  cout<<"**************"<<endl;
  cout<<endl;
  cout<<"1. Hauteur de T : "<<hauteur(T)<<endl;
  cout<<"2. Nombre de noeuds de T à la profondeur "<<endl;
  for(int i=0;i<=4;++i){
    cout<<"  "<<i<<" : "<<nombre_profondeur(T,i)<<endl;
  }
  cout<<"3. Noeuds de T à la profondeur "<<endl;
  for(int i=0;i<=4;++i){
    cout<<"  "<<i<<" : ";
    affiche_profondeur(T,i);
    cout<<endl;
  }
   cout<<endl;
  cout<<"**************"<<endl;
  cout<<"* Exercice 5 *"<<endl;
  cout<<"**************"<<endl;
  cout<<endl;
  cout<<"1. T est-il plein ? : "<<est_plein(T)<<endl;
  cout<<"2. T est-il complet ? : "<<est_complet(T)<<endl;
  cout<<"3. T est-il equilibre ? : "<<est_equilibre(T)<<endl;
}
